Package org.apache.commons.math3.distribution

# Class UniformRealDistribution

java.lang.Object
org.apache.commons.math3.distribution.AbstractRealDistribution
org.apache.commons.math3.distribution.UniformRealDistribution

All Implemented Interfaces:
  `Serializable`, `RealDistribution`

public class UniformRealDistribution extends AbstractRealDistribution
Implementation of the uniform real distribution.

Since:
  3.0
See Also:
  - Uniform distribution (continuous), at Wikipedia
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final double`
`DEFAULT_INVERSE_ABSOLUTE_ACCURACY`
Deprecated.
as of 3.2 not used anymore, will be removed in 4.0

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

## Constructor Summary

Constructors
Constructor
Description
`UniformRealDistribution()`
Create a standard uniform real distribution with lower bound (inclusive) equal to zero and upper bound (exclusive) equal to one.
`UniformRealDistribution(double lower, double upper)`
Create a uniform real distribution using the given lower and upper bounds.
`UniformRealDistribution(double lower, double upper, double inverseCumAccuracy)`
Deprecated.
as of 3.2, inverse CDF is now calculated analytically, use `UniformRealDistribution(double, double)` instead.
`UniformRealDistribution(RandomGenerator rng, double lower, double upper)`
Creates a uniform distribution.
`UniformRealDistribution(RandomGenerator rng, double lower, double upper, double inverseCumAccuracy)`
Deprecated.
as of 3.2, inverse CDF is now calculated analytically, use `UniformRealDistribution(RandomGenerator, double, double)` instead.

## Method Summary

Modifier and Type
Method
Description
`double`
`cumulativeProbability(double x)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double`
`density(double x)`
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double`
`getNumericalMean()`
Use this method to get the numerical value of the mean of this distribution.
`double`
`getNumericalVariance()`
Use this method to get the numerical value of the variance of this distribution.
`double`
`getSupportLowerBound()`
Access the lower bound of the support.
`double`
`getSupportUpperBound()`
Access the upper bound of the support.
`double`
`inverseCumulativeProbability(double p)`
Computes the quantile function of this distribution.
`boolean`
`isSupportConnected()`
Use this method to get information about whether the support is connected, i.e.
`boolean`
`isSupportLowerBoundInclusive()`
Whether or not the lower bound of support is in the domain of the density function.
`boolean`
`isSupportUpperBoundInclusive()`
Whether or not the upper bound of support is in the domain of the density function.
`double`
`sample()`
Generate a random value sampled from this distribution.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`cumulativeProbability, getSolverAbsoluteAccuracy, logDensity, probability, probability, reseedRandomGenerator, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

@Deprecated public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY
Deprecated.
as of 3.2 not used anymore, will be removed in 4.0
Default inverse cumulative probability accuracy.

See Also:
  - Constant Field Values

## Constructor Details

### UniformRealDistribution

public UniformRealDistribution()
Create a standard uniform real distribution with lower bound (inclusive) equal to zero and upper bound (exclusive) equal to one.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

### UniformRealDistribution

public UniformRealDistribution(double lower, double upper) throws NumberIsTooLargeException
Create a uniform real distribution using the given lower and upper bounds.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `sample()` and `AbstractRealDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `lower` - Lower bound of this distribution (inclusive).
  `upper` - Upper bound of this distribution (exclusive).
Throws:
  `NumberIsTooLargeException` - if `lower >= upper`.

### UniformRealDistribution

@Deprecated public UniformRealDistribution(double lower, double upper, double inverseCumAccuracy) throws NumberIsTooLargeException
Deprecated.
as of 3.2, inverse CDF is now calculated analytically, use `UniformRealDistribution(double, double)` instead.
Create a uniform distribution.

Parameters:
  `lower` - Lower bound of this distribution (inclusive).
  `upper` - Upper bound of this distribution (exclusive).
  `inverseCumAccuracy` - Inverse cumulative probability accuracy.
Throws:
  `NumberIsTooLargeException` - if `lower >= upper`.

### UniformRealDistribution

@Deprecated public UniformRealDistribution(RandomGenerator rng, double lower, double upper, double inverseCumAccuracy)
Deprecated.
as of 3.2, inverse CDF is now calculated analytically, use `UniformRealDistribution(RandomGenerator, double, double)` instead.
Creates a uniform distribution.

Parameters:
  `rng` - Random number generator.
  `lower` - Lower bound of this distribution (inclusive).
  `upper` - Upper bound of this distribution (exclusive).
  `inverseCumAccuracy` - Inverse cumulative probability accuracy.
Throws:
  `NumberIsTooLargeException` - if `lower >= upper`.
Since:
  3.1

### UniformRealDistribution

public UniformRealDistribution(RandomGenerator rng, double lower, double upper) throws NumberIsTooLargeException
Creates a uniform distribution.

Parameters:
  `rng` - Random number generator.
  `lower` - Lower bound of this distribution (inclusive).
  `upper` - Upper bound of this distribution (exclusive).
Throws:
  `NumberIsTooLargeException` - if `lower >= upper`.
Since:
  3.1

## Method Details

### density

public double density(double x)
Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`

### cumulativeProbability

public double cumulativeProbability(double x)
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

### inverseCumulativeProbability

public double inverseCumulativeProbability(double p) throws OutOfRangeException
Computes the quantile function of this distribution. For a random variable `X` distributed according to this distribution, the returned value is

- `inf{x in R | P(Xinvalid input: '<'=x) >= p}` for `0 < p <= 1`,
- `inf{x in R | P(Xinvalid input: '<'=x) > 0}` for `p = 0`.

The default implementation returns

- `RealDistribution.getSupportLowerBound()` for `p = 0`,
- `RealDistribution.getSupportUpperBound()` for `p = 1`.

Specified by:
  `inverseCumulativeProbability` in interface `RealDistribution`
Overrides:
  `inverseCumulativeProbability` in class `AbstractRealDistribution`
Parameters:
  `p` - the cumulative probability
Returns:
  the smallest `p`-quantile of this distribution (largest 0-quantile for `p = 0`)
Throws:
  `OutOfRangeException` - if `p < 0` or `p > 1`

### getNumericalMean

public double getNumericalMean()
Use this method to get the numerical value of the mean of this distribution. For lower bound `lower` and upper bound `upper`, the mean is `0.5 * (lower + upper)`.

Returns:
  the mean or `Double.NaN` if it is not defined

### getNumericalVariance

public double getNumericalVariance()
Use this method to get the numerical value of the variance of this distribution. For lower bound `lower` and upper bound `upper`, the variance is `(upper - lower)^2 / 12`.

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

### getSupportLowerBound

public double getSupportLowerBound()
Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) > 0}`.

The lower bound of the support is equal to the lower bound parameter of the distribution.

Returns:
  lower bound of the support

### getSupportUpperBound

public double getSupportUpperBound()
Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) = 1}`.

The upper bound of the support is equal to the upper bound parameter of the distribution.

Returns:
  upper bound of the support

### isSupportLowerBoundInclusive

public boolean isSupportLowerBoundInclusive()
Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportUpperBoundInclusive

public boolean isSupportUpperBoundInclusive()
Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportConnected

public boolean isSupportConnected()
Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`

### sample

public double sample()
Generate a random value sampled from this distribution. The default implementation uses the inversion method.

Specified by:
  `sample` in interface `RealDistribution`
Overrides:
  `sample` in class `AbstractRealDistribution`
Returns:
  a random value.